/* TODO:
 * - probably fix some margins 
 * - dark mode is not super great
 * - fix select box styling
 * - responsive design for header, mostly
 */
:root {
  --text-color: #333;
  --primary-text-color: #cf451a;
  --background-color: #fff;
  --border-color: #ccc;
  --error-color: #e00;
  --article-background-color: #eee;
  --article-text-color: var(--text-color);
  --primary-button-background-color: var(--primary-text-color);
  --primary-button-text-color: var(--background-color);
}

@media (prefers-color-scheme: dark) {
  :root {
    --text-color: #ccc;
    --primary-text-color: #cf451a;
    --background-color: #333;
    --border-color: #888;
    --error-color: #e00;
    --article-background-color: #555;
    --primary-button-text-color: var(--text-color);
  }
}

* {
  box-sizing: border-box;
}

body {
  font-family: system-ui, sans-serif;
  font-size: 1.15em;
  color: var(--text-color);
  background-color: var(--background-color);
  line-height: 1.5;
}

header {
  padding: 0.5em;
}

header nav {
  display: grid;
  grid-template-columns: 1fr 2fr 1fr;
}

header nav ul {
  list-style: none;
  justify-self: center;
  align-self: center;
  display: inline-block;
  padding: 0;
  margin: 0;
}

header nav ul:first-child {
  justify-self: start;
}

header nav ul:last-child {
  justify-self: end;
}

header nav ul li {
  display: inline-block;
  margin: 0;
}

header nav ul li a {
  display: inline-block;
  text-decoration: none;
  font-weight: bold;
  margin: 0 0.5em;
  color: var(--primary-text-color);
}

header nav button, header nav select, table button {
  padding: 0.6em 1em;
  font-size: 75%;
  margin: 0;
  border-radius: 0.3em;
}

table {
  width: 100%;
  border-collapse: collapse;
  /** XXX why does this radius not work? */
  border-radius: 0.3em;
  border: 1px solid var(--border-color);
  margin: 0.5em 0;
}

table th {
  text-align: start;
  vertical-align: top;
  font-weight: bold;
}

table td, table th {
  padding: 0.5em;
}

table ul {
  padding-left: 1rem;
  margin: 0;
}

table form {
  display: inline;
  width: initial;
}

.end {
  text-align: end;
}

.error {
  color: var(--error-color);
}

a {
  color: var(--primary-text-color);
}

header nav ul {
  list-style: none;
  display: inline-block;
  padding: 0;
}

header nav form {
  display: inline-block;
  width: initial;
}

img {
  max-width: 100%;
  display: block;
  margin: 0 auto;
}

mark {
  padding: 0.2em;
  border-radius: 0.2em;
  font-weight: bold;
}

pre code {
  width: 100%;
  overflow: auto;
}

p.center {
  text-align: center;
}

code {
  font-size: 120%;
  color: var(--text-color);
  display: inline-block;
}

main {
  max-width: 40em;
  margin: 0 auto;
  padding: 0.5em;
}

main h1 {
  margin-top: 0;
  text-align: center;
}

main h2 {
  margin: 1em 0 0 0;
}

footer {
  text-align: center;
  font-size: small;
}

main form {
  margin-top: 0.5em;
  width: 100%;
}

input + small, textarea + small, label + small {
  opacity: 75%;
  display: block;
  margin-bottom: 1em;
}

fieldset {
  border: 0;
  padding: 0.5em 0 0 0;
  margin: 0.5em 0;
}

fieldset legend {
  width: 100%;
  font-weight: bold;
}

textarea, button, select, input[type="text"], input[type="number"], input[type="password"] {
  font: inherit;
  width: 100%;
  padding: 0.6em 1em;
  margin: 0.25em 0;
  color: var(--text-color);
  background-color: var(--background-color);
  border: 1px solid var(--border-color);
  border-radius: 0.3em;
}

button {
  cursor: pointer;
  width: initial;
  color: var(--primary-button-text-color);
  background-color: var(--primary-button-background-color);
  border: 1px solid var(--primary-button-background-color);
}

button:disabled {
  opacity: 25%;
  cursor: inherit;
}

label:has(> input[type="checkbox"]) {
  display: grid;
  grid-template-columns: 1em auto;
  gap: 0.5em;
}

label:has(> input[type="radio"]) {
  display: grid;
  grid-template-columns: 1em auto;
  gap: 0.5em;
}

input[type=checkbox] {
  transform: scale(1.5);
  accent-color: var(--primary-text-color);
}

input[type=radio] {
  transform: scale(1.5);
  accent-color: var(--primary-text-color);
}

details {
  margin: 0.5em 0;
}

article {
  background-color: var(--article-background-color);
  color: var(--article-text-color);
  padding: 1em;
  border-radius: 0.25em;
}

summary {
  padding: 0.5em 0;
  cursor: pointer;
  font-weight: bold;
  color: var(--primary-text-color);
}
